import pyunlocbox
# >>>
# Set the functions in the problem
gamma = 3.0
d = pyunlocbox.functions.dummy()
r = pyunlocbox.functions.norm_l1()
f = pyunlocbox.functions.norm_l2(w=M, y=subsampled_noisy_label_signal,
                                 lambda_=gamma)
# >>>
# Define the solver
G.compute_differential_operator()
L = G.D.toarray()
step = 0.999 / (1 + np.linalg.norm(L))
solver = pyunlocbox.solvers.mlfbf(L=L, step=step)
# >>>
# Solve the problem
x0 = subsampled_noisy_label_signal.copy()
prob1 = pyunlocbox.solvers.solve([d, r, f], solver=solver,
                                 x0=x0, rtol=0, maxit=1000)
# Solution found after 1000 iterations:
# objective function f(sol) = 2.024594e+02
# stopping criterion: MAXIT
# >>>
G.plot_signal(prob1['sol'])
